<?php // $Id$

class slinky_share_handler_field_share_links extends views_handler_field {

  function construct() {
    parent::construct();
    $this->additional_fields['nid'] = 'nid';
    $this->additional_fields['title'] = 'title';
    $this->additional_fields['type'] = 'type';
  }

  function query() {
    $this->ensure_my_table();
    $this->add_additional_fields();
  }

  function option_definition() {
    $options = parent::option_definition();
    $options['preset'] = 'default';

    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    
    $presets = array();
    foreach (array_keys(slinky_presets()) as $key) { 
      $presets[$key] = $key;
    }
    $form['preset'] = array(
      '#title' => t('Presets'),
      '#type' => 'select',
      '#options' => $presets, 
      '#default_value' => !empty($this->options['preset']) ? $this->options['preset'] : 'default',
    );

    // Remove the alteration stuff
    unset($form['alter']);
  }

  function render($values) {
    if (user_access('share content')) {
      $node = new stdClass();
      $node->nid = $values->{$this->aliases['nid']};
      $node->title = $values->{$this->aliases['title']};
      $node->type = $values->{$this->aliases['type']};
      $node->slinky_share = TRUE;
      if ($links['#items'] = slinky_share_node_links($node, $a3)) {
        $links['#slinky_preset'] = $this->options['preset'];
        return theme('slinky_share_links', $links); 
      }
    }
  }
}
