<?php // $Id$

/**
 * Form callback for the social network administration page.
 */
function slinky_site_admin(&$form_state) {
  $form = array();

  // List of social networking links
  $form['slinky_site_links'] = array(
    '#type' => 'textarea',
    '#title' => t('Social network links'),
    '#default_value' => join("\n", variable_get('slinky_site_links', array())), 
    '#description' => t('Add social network links for this site, one per line.'),
  );

  $form['slinky_site_blocks'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Create blocks'),
    '#options' => slinky_preset_names(),
    '#default_value' => variable_get('slinky_site_blocks', array()),
    '#description' => t('Enable one or more blocks, which can be enabled on the !blocks.  You might want to create a large set of icons for the front page and a smaller version for discreet placement throughout the site.', array('!blocks' => l(t('Blocks adminstration page'), 'admin/build/block'))),
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );
  
  return $form;
}

/**
 * Form validation handler for slinky_site_admin().
 */
function slinky_site_admin_validate($form, &$form_state) {
  $links = explode("\n", trim($form_state['values']['slinky_site_links']));
  foreach ($links as $key => $row) {
    $link = array();
    $row = explode('|', $row);
    if (count($row) == 2) {
      list($link['title'], $link['href']) = $row;
    }
    else $link['href'] = $row[0];

    // This entry can't be parsed!
    if (!$info = slinky_link_info($link['href'])) {
      if (substr($link['href'], 4) != 'http') {
        if ($info = slinky_link_info('http://'. $link['href'])) {
          $link['href'] = 'http://'. $link['href'];
        }
      }
      else {
        // Set warning
      }
    }

    if ($info && !isset($link['title'])) {
      // No title was defined.  Set one based on the site's name.
      $link['title'] = $info['title'];
    }

    $links[$key] = $link['title'] .'|'. $link['href'];
  }
  form_set_value($form['slinky_site_links'], join("\n", $links), $form_state); 
}

/**
 * Form submit handler for slinky_site_admin().
 */
function slinky_site_admin_submit($form, &$form_state) {
  variable_set('slinky_site_links', explode("\n", $form_state['values']['slinky_site_links']));
  variable_set('slinky_site_blocks', array_filter($form_state['values']['slinky_site_blocks']));
  drupal_set_message(t('Social network links saved.  If you haven\'t already done so, you can visit the !blocks to enable your social network blocks.', array('!blocks' => l(t('blocks adminstration page'), 'admin/build/block'))));
}
